<template>
    <div class="app-container">
        <div class="filter-container">
            <div style="display: block">
                <div class="basic_search">
                    <span>区域：</span>
                    <el-select v-model="listQuery.filter.province" clearable filterable @change="changeArea('province')">
                        <el-option
                            v-for="item in provinceList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
                <div class="basic_search">
                    <el-select v-model="listQuery.filter.city" prop="city" clearable filterable @change="changeArea('city')">
                        <el-option
                            v-for="item in cityList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
                <div class="basic_search">
                    <el-select v-model="listQuery.filter.district" clearable filterable @change="changeArea('district')">
                        <el-option
                            v-for="item in districtList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
                <div class="basic_search">
                    <el-select v-model="listQuery.filter.street"clearable filterable @change="changeArea('street')" >
                        <el-option
                            v-for="item in streetList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>
                <div class="basic_search">
                    <el-select v-model="listQuery.filter.committee" clearable filterable>
                        <el-option
                            v-for="item in committeeList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.name"
                        >
                        </el-option>
                    </el-select>
                </div>

            </div>
                <div class="basic_search" style="padding-top: 10px">
                    <span>产品名称：</span>
                    <el-input filterable clearable v-model="listQuery.filter.productname" style="width:200px">

                    </el-input>
                </div>
                 <span>产品名称：</span>
                <div class="basic_search" style="padding-top: 10px">
                    <el-select v-model="listQuery.filter.producttype" clearable placeholder="请选择" style="margin-left: 10px;"
                               @change="getProductSecondaryCategory">
                        <el-option
                            class="filter-item"
                            v-for="item in typeOptions"
                            :key="item.attributes"
                            :label="item.text"
                            :value="item.attributes">{{item.text}}
                        </el-option>
                    </el-select>
                    <el-select v-model="listQuery.filter.secondarytype" clearable placeholder="请选择" style="margin-left: 10px"
                     @change="changeSelect">
                        <el-option
                            v-for="item in secondaryOptions"
                            :key="item.attributes"
                            :label="item.text"
                            :value="item.attributes">
                        </el-option>
                    </el-select>
                </div>
            <div style="display: block;">
                <div class="basic_search" style="padding-top: 10px;">
                    <span>时间查询：</span>
                    <el-date-picker
                        value-format="yyyy-MM-dd HH:mm:ss"
                        v-model="validTime"
                        type="datetimerange"
                        :default-time="['00:00:00','23:59:59']"
                        :picker-options="pickerOptions"
                        range-separator="-"
                        start-placeholder="开始日期"
                        end-placeholder="结束日期"
                    >
                    </el-date-picker>
                </div>
            </div>
            <div style="display: block;">
                <div class="basic_search" style="padding-top: 10px">
                    <span>企业名称：</span>
                    <el-input filterable clearable v-model="listQuery.filter.enterprisename" style="width:200px">
                    </el-input>
                </div>
                <div class="basic_search" style="margin-right: 10px">
                    <el-button style="margin-left: 10px;" type="primary" @click="reset()">重置</el-button>
                    <el-button style="margin-left: 10px;" type="primary" icon="el-icon-search" @click="searchRaceSaleList('查询','')">查询</el-button>
                    <el-button style="margin-left: 10px;" type="primary" icon="el-icon-download" @click="exportToExcel">导出</el-button>
                </div>
            </div>


        </div>
        <div class="table_content">
            <el-table
                v-loading="listLoading"
                :key="tableKey"
                :data="personPurchaseData"
                border
                fit
                highlight-current-row
                style="width: 100%;">
                <el-table-column label="序号" type="index" align="center" width="60"/>
                <el-table-column label="名族" prop="nation" align="center">
                </el-table-column>
                <el-table-column label="数量" prop="sum" align="center">
                </el-table-column>
            </el-table>
            <br>
            <el-pagination
                v-show="recordTotal>0"
                :current-page="currentPage"
                :page-sizes="[20, 50, 100, 200]"
                :page-size="pageSize"
                :total="recordTotal"
                layout="total, sizes, prev, pager, next, jumper"
                background
                style="float:right;"
                @size-change="handleSizeChange"
                @current-change="handleCurrentChange"></el-pagination>
            <br>
        </div>
    </div>
</template>

<script>
import { computePageCount } from "../../utils";
import {exportPerson, getRaceSale,getGenderSale} from "../../api/productPurchaseSearch";
import {getCityListData, getProvinceListData , } from "../../api/area";
import {dictionaryAllItems} from "../../api/dictionary";
import {
  createProduct,
  deleteProduct,
  getMajorCategoryTree,
  getManufacturerTree, getSecondaryCategoryTree,
  productList,
  updateProduct
} from "../../api/product";

export default {
    name: "addSelfExam",
    data(){
        return{
            tableKey:'',
          validTime:['',''],
          cityList:[],
          provinceList:[],
          districtList:[],
          streetList:[],
          committeeList:[],
            listQuery: {
                pageSize:20,
                pageIndex:1,
                filter: {
                  province: '',
                  city: '',
                  district: '',
                  street: '',
                  committee: '',
                  starttime: '',
                  endtime: '',
                  enterprisename: '',
                  productname:'',
                  producttype:'',
                },
            },
            pageSize: 20,
            recordTotal: 0,
            currentPage: 1,
            pageTotal: 0,
            listLoading:false,
          typeOptions: [],
          secondaryOptions:[],
            personPurchaseData:[],
          pickerOptions: {
            shortcuts: [{
              text: '最近一周',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                picker.$emit('pick', [start, end]);
              }
            }, {
              text: '最近一个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                picker.$emit('pick', [start, end]);
              }
            }, {
              text: '最近三个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                picker.$emit('pick', [start, end]);
              }
            }]
          },
        }
    },

    created() {
       this.initValidTime()
        this.getRaceSaleList(),
          this.getProvince(),
          this.getProductMajorCategory();
    },
    watch: {
    },
    methods:{

      async changeSelect(){
        this.$forceUpdate();
      },

        async getRaceSaleList(){
            this.listLoading = true
          if( this.validTime !== null ){
            this.listQuery.filter.starttime = this.validTime[0]
            this.listQuery.filter.endtime = this.validTime[1]
          }else{
            this.listQuery.filter.starttime = ''
            this.listQuery.filter.endtime = ''
          }
            let res = await getRaceSale(this.listQuery)
            if(res.data.code === "200"){
                this.recordTotal = res.data.result.total
                this.pageSize = res.data.result.size
                this.pageTotal = computePageCount(res.data.result.total, res.data.result.size)
                this.currentPage = res.data.result.current
                this.personPurchaseData = res.data.result.records
            }else{
                this.$message({
                    type:'warning',
                    message:res.data.message
                })
            }
            this.listLoading = false
        },


      getProductMajorCategory(){
        getMajorCategoryTree().then(res=>{
          this.typeOptions = res.data;
        })
      },
      getProductSecondaryCategory(major){
        this.secondaryOptions = [];
        this.listQuery.filter.secondarytype = "";
        this.secondarytype = "";
        getSecondaryCategoryTree(major).then(res=>{
          this.secondaryOptions = res.data;
        })
      },
        async exportToExcel(){
            if( this.validTime !== null ){
                this.listQuery.filter.starttime = this.validTime[0]
                this.listQuery.filter.endtime = this.validTime[1]
            }else{
                this.listQuery.filter.starttime = ''
                this.listQuery.filter.endtime = ''
            }
            let res = await exportPerson(this.listQuery)
            if(res.data.code === '200'){
                if(res.data.result === null ||res.data.result === [] || res.data.result.length === 0){
                    this.$message({
                        type:'warning',
                        message:'无数据可导出'
                    })
                }else{
                    let allData = res.data.result
                    import('@/vendor/Export2Excel').then((excel) => {
                        const tHeader = [
                            '公司名称',
                            '公司编号',
                            '购买人姓名',
                            '购买人身份证',
                            '购买数量',
                            '最近购买时间',
                        ]
                        const filterVal = [
                            'enterprisename',
                            'companynumber',
                            'name',
                            'identify',
                            'num',
                            'saletime',
                        ]
                        const data = this.formatJson(filterVal, allData)
                        excel.export_json_to_excel({
                            header: tHeader,
                            data,
                            filename: '实名销售分析'
                        })
                    })
                }

            }else{
                this.$message({
                    message:res.data.message,
                    type:'warning'
                })
            }
        },

        formatJson(filterVal, jsonData) {
            return jsonData.map(v => filterVal.map(j => v[j]))
        },

        async getProvince(){
          let res = await getProvinceListData()
          if(res.data.code === "200"){
            this.provinceList = res.data.result.provinceList
          }
        },

      async changeArea(value){
        if(value === 'province'){
          this.listQuery.filter.city = ''
          this.listQuery.filter.district = ''
          this.listQuery.filter.street = ''
          this.listQuery.filter.committee = ''
          this.areaListQuery = {
            type: 2,
            parenttype: 1,
            parentname: this.listQuery.filter.province,
          }
          let res = await getCityListData(this.areaListQuery)
          if(res.data.code === "200"){
            this.cityList = res.data.result
          }
        }else if(value === 'city'){
          this.listQuery.filter.district = ''
          this.listQuery.filter.street = ''
          this.listQuery.filter.committee = ''
          this.areaListQuery = {
            type: 3,
            parenttype: 2,
            parentname: this.listQuery.filter.city,
          }
          let res = await getCityListData(this.areaListQuery)
          if(res.data.code === "200"){
            this.districtList = res.data.result
          }
        }else if(value === 'district'){
          this.listQuery.filter.street = ''
          this.listQuery.filter.committee = ''
          this.areaListQuery = {
            type: 4,
            parenttype: 3,
            parentname: this.listQuery.filter.district,
          }
          let res = await getCityListData(this.areaListQuery)
          if(res.data.code === "200"){
            this.streetList = res.data.result
          }
        }else if(value === 'street'){
          this.listQuery.filter.committee = ''
          this.areaListQuery = {
            type: 5,
            parenttype: 4,
            parentname: this.listQuery.filter.street,
          }
          let res = await getCityListData(this.areaListQuery)
          if(res.data.code === "200"){
            this.committeeList = res.data.result
          }
        }
      },//市、镇、街道、委员会

      reset(){
            this.listQuery= {
                pageSize: 10,
                pageIndex: 1,
                filter: {
                  province: '',
                  city: '',
                  district: '',
                  street: '',
                  committee: '',
                  starttime: '',
                  endtime: '',
                  enterprisename: '',
                  productname:'',
                  producttype:'',
                },
            }
        },

        searchRaceSaleList(){
            this.getRaceSaleList()
        },

        handleSizeChange(val) {
            this.listQuery.pageSize = val
            this.getRaceSaleList()
        },
        handleCurrentChange(val) {
            this.listQuery.pageIndex = val
            this.getRaceSaleList()
        },
      initValidTime(){
        const start = new Date();
        const end = new Date();
        start.setTime(end.getTime() - 3600 * 1000 * 24 * 6);
        this.validTime[0] = [start.getFullYear(), start.getMonth() + 1, start.getDate()].join("-") + " 00:00:00" ;
        this.validTime[1] = [end.getFullYear(), end.getMonth() + 1, end.getDate()].join("-") +" 23:59:59";
      }
    },
}
</script>

<style scoped>
.basic_search{
    display:inline-block;
}

</style>
